/* gcc_cpp */

/* 
 * Problem  : Order
 * Contest  : UOI-2007 (Kremenchug)
 * Type     : Solution
 * Date     : April 1, 2007
 * Version  : 1.0
 * Author   : Andrii Grynenko
 * Language :	C++
 * Compiler :	GNU C++
 * Algorithm:	Author Solution
 */
 
#include <cstdio>
#include <iostream>
#include <vector>
#include <algorithm>

using namespace std;

#define INF 1000000000000000000LL

struct Minimizator {
    vector <long long> a, l, r;
    int n;
    #define PREV(x) (x & (x - 1))
    #define NEXT(X) ((x << 1) - PREV(x))
    long long getMin(int q, int w) {
        q++;    w++;
        static int x;
        static long long v;
        v = INF;
        for(x = q; NEXT(x) <= w;x = NEXT(x)) v <?= r[x];
        v <?= a[x];
        for(x = w; PREV(x) >= q;x = PREV(x)) v <?= l[x];        
        return v;
    }
    void modify(int p,long long v) {
        p++;
        static int x;
        a[p] <?= v;
        for(x = p; x <= n; x = NEXT(x)) l[x] <?= v;
        for(x = p; x; x = PREV(x)) r[x] <?= v;        
    }
    Minimizator(int _n): a(_n+1), l(_n+1), r (_n+1) {
        n = _n;
        for (int i=0; i<=n; i++) {        
            a[i] = l[i] = r[i] = INF;
        }
    }
};

vector <int> x;

int getx (int X)
{
	return lower_bound(x.begin(), x.end(), X)-x.begin (); 
}

int main ()
{
	int n, x0, m;
	long long res;
	
	freopen ("order.dat", "r", stdin);
	freopen ("order.sol", "w", stdout);
	
	scanf ("%d", &n);
	
	vector <int> orders(n); 
	
	for (int i=0; i<n; i++)
		scanf ("%d", &orders[i]);
	
	x = orders;
	x.push_back (0);
	sort (x.begin(), x.end ());
	x.resize (unique (x.begin(), x.end())-x.begin());
	m = x.size ();
	
	res = 0;
	x0 = getx (0);
	
	Minimizator left(m), right(m);
	
	left.modify (x0,0);
	right.modify (x0,0);
	
	int curx = 0;
	
	for (int i=0; i<n; i++)
	{
		int x = getx (orders[i]);
		long long value = min (left.getMin(0, x)+orders[i], right.getMin(x, m-1)-orders[i])-abs(orders[i]-curx);
		left.modify (x0,value-curx);
		right.modify (x0,value+curx);
		res += abs (orders[i]-curx);
		curx = orders[i];
		x0 = x;	
	}
	
	long long r = INF;
	for (int i=1; i<=m; i++)
	{
		r = min (r, res+left.a[i]+x[i-1]);
	}
	cout << r << endl;
		
	return 0;
}

