{ fp }

{
 Problem  : Order
 Contest  : UOI-2007 (Kremenchug)
 Type     : Solution
 Date     : April 1, 2007
 Version  : 1.0
 Author   : Andrii Grynenko
 Language :	C++
 Compiler :	GNU C++
 Algorithm:	Author Solution
}

uses math;

const INF =  1000000000000000000;
const maxN = 1000000;



var
  x: array [1..maxN+1] of longint;
  n: longint;
  nn: longint;
  res: int64;
  a1, l1, r1, a2, l2, r2: array [1..maxN] of int64;
  orders: array [1..maxN] of longint;
  input, output: text;
  i, j: longint;
  x0 : longint;
  curx : longint;
  value, r : int64;

function next(x:longint):longint; begin next:=(x shl 1) - (x and (x-1)); end;
function prev(x:longint):longint; begin prev:=(x and (x - 1)); end;

procedure left_modify(p:longint;value:int64);
 var
   x: longint;
 begin
   a1[p]:=min(a1[p],value);
   x:=p;
   while x<=n do
    begin
      l1[x]:=min(l1[x],value);
      x:=next(x);
    end;
   x:=p;
   while x>0 do
    begin
      r1[x]:=min(r1[x],value);
      x:=prev(x);
    end;
 end;
function left_getmin(q,w:longint):int64;
 var
   res: int64;
   x: longint;
 begin
   res:=INF;
   x:=q;
   while next(x)<=w do
    begin
      res:=min(res,r1[x]);
      x:=next(x);
    end;
   res:=min(res,a1[x]);
   x:=w;
   while prev(x)>=q do
    begin
      res:=min(res,l1[x]);
      x:=prev(x);
    end;
   left_getmin:=res;
 end;

procedure right_modify(p:longint;value:int64);
 var
   x: longint;
 begin
   a2[p]:=min(a2[p],value);
   x:=p;
   while x<=n do
    begin
      l2[x]:=min(l2[x],value);
      x:=next(x);
    end;
   x:=p;
   while x>0 do
    begin
      r2[x]:=min(r2[x],value);
      x:=prev(x);
    end;
 end;
function right_getmin(q,w:longint):int64;
 var
   res: int64;
   x: longint;
 begin
   res:=INF;
   x:=q;
   while next(x)<=w do
    begin
      res:=min(res,r2[x]);
      x:=next(x);
    end;
   res:=min(res,a2[x]);
   x:=w;
   while prev(x)>=q do
    begin
      res:=min(res,l2[x]);
      x:=prev(x);
    end;
   right_getmin:=res;
 end;

function getx (xx: longint): longint;
var
  a, b, c: longint;
begin
  a:= 1;
  b:= n;
  while a<b do begin
    c:= (a+b+1) div 2;
    if x[c]>xx then
      b:= c-1
    else
      a:= c;
  end;
  getx:= a;
end;

procedure sort(l,r: longint);
var
  i,j,xx,yy: longint;
begin
  i:=l; j:=r; xx:=x[l+random(r-l+1)];
  repeat
    while x[i]<xx do i:=i+1;
    while xx<x[j] do j:=j-1;
    if i<=j then begin
      yy:=x[i]; x[i]:=x[j]; x[j]:=yy;
      i:=i+1; j:=j-1;
    end;
  until i>j;
  if l<j then sort(l,j);
  if i<r then sort(i,r);
end;

procedure unique (m : longint);
var
  i: longint;
begin
  n:=1;
  for i:=2 to m do
    if x[i]>x[n] then begin
      inc (n);
      x[n] := x[i];
    end;
end;

begin
  randomize;

  assign (input, 'order.dat');
  reset (input);
  assign (output, 'order.sol');
  rewrite (output);

  read (input, nn);

  for i:=1 to nn do begin
    read (input, orders[i]);
    x[i]:=orders[i];
  end;
  x[nn+1]:=0;
  sort (1, nn+1);
  unique (nn+1);
  for i:=1 to n do begin
    a1[i]:=INF;
    a2[i]:=INF;
    l1[i]:=INF;
    l2[i]:=INF;
    r1[i]:=INF;
    r2[i]:=INF;
  end;

  res := 0;
  x0 := getx (0);

  left_modify (x0,0);
  right_modify (x0,0);

  curx := 0;

  for i:=1 to nn do begin
     j := getx (orders[i]);
     value := min (left_getMin(1, j)+orders[i], right_getMin(j, n)-orders[i])-abs(orders[i]-curx);
     left_modify (x0,value-curx);
     right_modify (x0,value+curx);
     res := res + abs (orders[i]-curx);
     curx := orders[i];
     x0 := j;
  end;

  r := INF;
  for i:=1 to n do
    r := min (r, res+a1[i]+x[i]);

  writeln (output, r);

  close (input);
  close (output)
end.

